# KSPSetResidualHistory

Sets the array used to hold the residual history. If set, this array will contain the residual norms computed at each iteration of the solver.

### Synopsis

    #include "petscksp.h"
    PetscErrorCode PETSCKSP_DLLEXPORT KSPSetResidualHistory(KSP ksp,PetscReal a[],PetscInt na,PetscTruth reset)

Not Collective

### Input Parameters

| ksp | - iterative context obtained from KSPCreate()
| a | - array to hold history
| na | - size of a
| reset | - PETSC_TRUE indicates the history counter is reset to zero for each new linear solve

Notes: The array is NOT freed by PETSc so the user needs to keep track of it and destroy once the KSP object is destroyed.

If 'na' is PETSC_DECIDE or PETSC_DEFAULT, or 'a' is PETSC_NULL, then a default array of length 10000 is allocated.

### Keywords

KSP, set, residual, history, norm

### See Also

KSPGetResidualHistory()

Level:advanced
Location: src/ksp/ksp/interface/itfunc.c
Index of all KSP routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/snes/examples/tutorials/ex6.c.html